//
// Created by zygzagz on 02.01.2021.
//

#ifndef ZAD2_VARIABLE_H
#define ZAD2_VARIABLE_H

#include <utility>

#include "../TypeDefs.h"

class Variable : std::enable_shared_from_this<Variable> {
public:
	Variable() = default;
	explicit Variable(VarInfoPtr info) : info(std::move(info)), constExpr(false), val(0) {};
	explicit Variable(int constVal) : type(new Int), constExpr(true), val(constVal) {};
	explicit Variable(std::string symbolName) {};
	VarInfoPtr info;
	TypePtr type;
	bool constExpr;
	int val;
	std::string name;
	// chcemy znać lokalizację w pamięci gdzie zapisać z powrotem i gdzie leży ogólnie
	// lok. może nie być, jeśli to tymczasowa
	// registers
	// is mem?
	// where in mem - id or offset
};

class VariableLocation {
public:
	VariableLocation() = default;
	VariableLocation(VariablePtr base, VariablePtr index, int multiplier, int offset)
		: base(std::move(base)), index(std::move(index)), multiplier(multiplier), offset(offset)
	{}
	VariablePtr base;
	VariablePtr index;
	int multiplier;
	int offset;

	string toString() const {
		std::string ret = "[" + base->name;
		if (multiplier || !(index->constExpr || !index->val)) ret += " + " + to_string(multiplier) + "*" + index->name;
		if (offset) ret += " + " + to_string(offset);
		return ret + "]";
	}
};

#endif //ZAD2_VARIABLE_H
